/***********************************************************************

  LCD  ATmega32    : 

http://www.radiokot.ru/forum/viewtopic.php?t=5199&postdays=0&postorder=asc&start=20

:  lexmulya  ( 17, 2007 10:11 am)     . 
               
   (     ). 
  ,      . 
          
         , 
   ,    70 .

*************************************************************************
                      

AVR123.NM.RU -     CVAVR    PROTEUS  
     

LCD           ATmega32     12 

DI    PA0 
RW    PA1
E     PA2
CS1   PA3 
CS2   PA4
RST   PA5

 PCx      DBx  LCD

   CVAVR 1.25.8 pro,    , 

    PROTEUS 7.2
                                                            
*******************************  2008-05-16  ******************************

  :

http://www.roboforum.ru/viewtopic.php?f=2&t=1070

     AVR  -  www.AVR123.NM.RU

   PROTEUS  -  oProteus.narod.ru  -    !

    AVR  -  www.AVR123.NM.RU/06.htm

*************************************************************************/


// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega64


#pragma used+
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm



// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-



//========================================================================================================
/*   */


flash const char sym[160][5] = 
flash const char sym[160][5] = 
flash const char sym[160][5] = 
{
 {0x00,0x00,0x00,0x00,0x00},                    //
 {0x00,0x00,0x4f,0x00,0x00},                    //!
 {0x00,0x07,0x00,0x07,0x00},                    //"
 {0x14,0x7f,0x14,0x7f,0x14},                    //#
 {0x24,0x2a,0x7f,0x2a,0x12},                    //$
 {0x23,0x13,0x08,0x64,0x62},                    //%
 {0x36,0x49,0x55,0x22,0x40},                    //&
 {0x00,0x05,0x03,0x00,0x00},                    //,
 {0x00,0x1c,0x22,0x41,0x00},                    //(
 {0x00,0x41,0x22,0x1c,0x00},                    //)
 {0x14,0x08,0x3E,0x08,0x14},                    //*
 {0x08,0x08,0x3E,0x08,0x08},                    //+
 {0x00,0x50,0x30,0x00,0x00},                    //,
 {0x08,0x08,0x08,0x08,0x08},                    //-
 {0x00,0x60,0x60,0x00,0x00},                    //.
 {0x20,0x10,0x08,0x04,0x02},                    ///
 {0x3e,0x51,0x49,0x45,0x3e},                    //0
 {0x00,0x42,0x7f,0x40,0x00},                    //1
 {0x42,0x61,0x51,0x49,0x46},                    //2
 {0x21,0x41,0x45,0x4b,0x31},                    //3
 {0x18,0x14,0x12,0x7f,0x10},                    //4
 {0x27,0x45,0x45,0x45,0x39},                    //5
 {0x3c,0x4a,0x49,0x49,0x30},                    //6
 {0x01,0x71,0x09,0x05,0x03},                    //7
 {0x36,0x49,0x49,0x49,0x36},                    //8
 {0x06,0x49,0x49,0x29,0x1e},                    //9
 {0x00,0x36,0x36,0x00,0x00},                    //:
 {0x00,0x56,0x36,0x00,0x00},                    //;
 {0x08,0x14,0x22,0x41,0x00},                    //<
 {0x14,0x14,0x14,0x14,0x14},                    //=
 {0x00,0x41,0x22,0x14,0x08},                    //>
 {0x02,0x01,0x51,0x09,0x06},                    //?
 {0x32,0x49,0x71,0x41,0x3e},                    //@
 {0x7e,0x11,0x11,0x11,0x7e},                    //A
 {0x7f,0x49,0x49,0x49,0x36},                    //B
 {0x3e,0x41,0x41,0x41,0x22},                    //C
 {0x7f,0x41,0x41,0x22,0x1c},                    //D
 {0x7f,0x49,0x49,0x49,0x41},                    //E
 {0x7f,0x09,0x09,0x09,0x01},                    //F
 {0x3e,0x41,0x49,0x49,0x3a},                    //G
 {0x7f,0x08,0x08,0x08,0x7f},                    //H
 {0x00,0x41,0x7f,0x41,0x00},                    //I
 {0x20,0x40,0x41,0x3f,0x01},                    //J
 {0x7f,0x08,0x14,0x22,0x41},                    //K
 {0x7f,0x40,0x40,0x40,0x40},                    //L
 {0x7f,0x02,0x0c,0x02,0x7f},                    //M
 {0x7f,0x04,0x08,0x10,0x7f},                    //N
 {0x3e,0x41,0x41,0x41,0x3e},                    //O
 {0x7f,0x09,0x09,0x09,0x06},                    //P
 {0x3e,0x41,0x51,0x21,0x5e},                    //Q
 {0x7f,0x09,0x19,0x29,0x46},                    //R
 {0x46,0x49,0x49,0x49,0x31},                    //S
 {0x01,0x01,0x7f,0x01,0x01},                    //T
 {0x3f,0x40,0x40,0x40,0x3f},                    //U
 {0x1f,0x20,0x40,0x20,0x1f},                    //V
 {0x3f,0x40,0x70,0x40,0x3f},                    //W
 {0x63,0x14,0x08,0x14,0x63},                    //X
 {0x07,0x08,0x70,0x08,0x07},                    //Y
 {0x61,0x51,0x49,0x45,0x43},                    //Z
 {0x00,0x7F,0x41,0x41,0x00},                    //[
 {0x02,0x04,0x08,0x10,0x20},                    //\ 
 {0x00,0x41,0x41,0x7F,0x00},                    //]
 {0x04,0x02,0x01,0x02,0x04},                    //^
 {0x40,0x40,0x40,0x40,0x40},                    //_      
 {0x00,0x01,0x02,0x04,0x00},                    //'
 {0x20,0x54,0x54,0x54,0x78},                    //a
 {0x7F,0x48,0x44,0x44,0x38},                    //b
 {0x38,0x44,0x44,0x44,0x20},                    //c
 {0x38,0x44,0x44,0x48,0x7F},                    //d
 {0x38,0x54,0x54,0x54,0x18},                    //e
 {0x08,0x7E,0x09,0x01,0x02},                    //f
 {0x0C,0x52,0x52,0x52,0x3E},                    //g
 {0x7F,0x08,0x04,0x04,0x78},                    //h
 {0x00,0x44,0x7D,0x40,0x00},                    //i
 {0x20,0x40,0x44,0x3D,0x00},                    //j
 {0x7F,0x10,0x28,0x44,0x00},                    //k
 {0x00,0x41,0x7F,0x40,0x00},                    //l
 {0x7C,0x04,0x18,0x04,0x78},                    //m
 {0x7C,0x08,0x04,0x04,0x78},                    //n
 {0x38,0x44,0x44,0x44,0x38},                    //o
 {0x7C,0x14,0x14,0x14,0x08},                    //p
 {0x08,0x14,0x14,0x18,0x7C},                    //q
 {0x7C,0x08,0x04,0x04,0x08},                    //r
 {0x48,0x54,0x54,0x54,0x20},                    //s
 {0x04,0x3F,0x44,0x40,0x20},                    //t
 {0x3C,0x40,0x40,0x20,0x7C},                    //u
 {0x1C,0x20,0x40,0x20,0x1C},                    //v
 {0x3C,0x40,0x30,0x40,0x3C},                    //w
 {0x44,0x28,0x10,0x28,0x44},                    //x
 {0x0C,0x50,0x50,0x50,0x3C},                    //y
 {0x44,0x64,0x54,0x4C,0x44},                    //z
 {0x00,0x08,0x36,0x41,0x00},                    //{
 {0x00,0x00,0x7f,0x00,0x00},                    //|
 {0x00,0x41,0x36,0x08,0x00},                    //}
 {0x02,0x01,0x02,0x02,0x01},                    //~
 {0x00,0x00,0x00,0x00,0x00},                    //
 {0x7e,0x11,0x11,0x11,0x7e},                    //A
 {0x7f,0x49,0x49,0x49,0x33},                    //
 {0x7f,0x49,0x49,0x49,0x36},                    //
 {0x7f,0x01,0x01,0x01,0x03},                    //
 {0xe0,0x51,0x4f,0x41,0xff},                    //
 {0x7f,0x49,0x49,0x49,0x41},                    //E
 {0x77,0x08,0x7f,0x08,0x77},                    //
 {0x41,0x49,0x49,0x49,0x36},                    //
 {0x7f,0x10,0x08,0x04,0x7f},                    //
 {0x7c,0x21,0x12,0x09,0x7c},                    //
 {0x7f,0x08,0x14,0x22,0x41},                    //K
 {0x20,0x41,0x3f,0x01,0x7f},                    //
 {0x7f,0x02,0x0c,0x02,0x7f},                    //M
 {0x7f,0x08,0x08,0x08,0x7f},                    //H
 {0x3e,0x41,0x41,0x41,0x3e},                    //O
 {0x7f,0x01,0x01,0x01,0x7f},                    //
 {0x7f,0x09,0x09,0x09,0x06},                    //P
 {0x3e,0x41,0x41,0x41,0x22},                    //C
 {0x01,0x01,0x7f,0x01,0x01},                    //T
 {0x47,0x28,0x10,0x08,0x07},                    //
 {0x1c,0x22,0x7f,0x22,0x1c},                    //
 {0x63,0x14,0x08,0x14,0x63},                    //X
 {0x7f,0x40,0x40,0x40,0xff},                    //
 {0x07,0x08,0x08,0x08,0x7f},                    //
 {0x7f,0x40,0x7f,0x40,0x7f},                    //
 {0x7f,0x40,0x7f,0x40,0xff},                    //
 {0x01,0x7f,0x48,0x48,0x30},                    //
 {0x7f,0x48,0x30,0x00,0x7f},                    //
 {0x00,0x7f,0x48,0x48,0x30},                    //
 {0x22,0x41,0x49,0x49,0x3e},                    //
 {0x7f,0x08,0x3e,0x41,0x3e},                    //
 {0x46,0x29,0x19,0x09,0x7f},                    // 
 {0x20,0x54,0x54,0x54,0x78},                    //a
 {0x3c,0x4a,0x4a,0x49,0x31},                    //
 {0x7c,0x54,0x54,0x28,0x00},                    //
 {0x7c,0x04,0x04,0x04,0x0c},                    //
 {0xe0,0x54,0x4c,0x44,0xfc},                    //
 {0x38,0x54,0x54,0x54,0x18},                    //e
 {0x6c,0x10,0x7c,0x10,0x6c},                    //
 {0x44,0x44,0x54,0x54,0x28},                    //
 {0x7c,0x20,0x10,0x08,0x7c},                    //
 {0x7c,0x41,0x22,0x11,0x7c},                    //
 {0x7c,0x10,0x28,0x44,0x00},                    //
 {0x20,0x44,0x3c,0x04,0x7c},                    //
 {0x7c,0x08,0x10,0x08,0x7c},                    //
 {0x7c,0x10,0x10,0x10,0x7c},                    //
 {0x38,0x44,0x44,0x44,0x38},                    //o
 {0x7c,0x04,0x04,0x04,0x7c},                    //
 {0x7C,0x14,0x14,0x14,0x08},                    //p 
 {0x38,0x44,0x44,0x44,0x20},                    //c
 {0x04,0x04,0x7c,0x04,0x04},                    //
 {0x0C,0x50,0x50,0x50,0x3C},                    //
 {0x30,0x48,0xfc,0x48,0x30},                    //
 {0x44,0x28,0x10,0x28,0x44},                    //x
 {0x7c,0x40,0x40,0x40,0xfc},                    //
 {0x0c,0x10,0x10,0x10,0x7c},                    //
 {0x7c,0x40,0x7c,0x40,0x7c},                    //
 {0x7c,0x40,0x7c,0x40,0xfc},                    //
 {0x04,0x7c,0x50,0x50,0x20},                    //
 {0x7c,0x50,0x50,0x20,0x7c},                    //
 {0x7c,0x50,0x50,0x20,0x00},                    //
 {0x28,0x44,0x54,0x54,0x38},                    //
 {0x7c,0x10,0x38,0x44,0x38},                    //
 {0x08,0x54,0x34,0x14,0x7c}                   //
};
// 
//     

                 //   AVR123.NM.RU  
                 // LCD           ATmega32

//   

//              //   AVR123.NM.RU


//  
//  
unsigned char met;
unsigned char met;
unsigned char met;
// .   
//                            
/*   .     */
unsigned char ReadCode( void ){
unsigned char ReadCode( void ){
    unsigned char ret;
    //   
    PORTE =0x00;
    DDRE=0x00; 
    //      
    (PORTA&=~(1<<0     ));
    (PORTA|=(1<<1   )); 
    //                   
    delay_us(2); 
    (PORTA|=(1<<2      )); 
    //                   
    delay_us(2);
    ret=PINE;         
    //     
    (PORTA&=~(1<<2      ));
    return ret;
}  


/*    */
void WaitBusy(void){
    unsigned char stat;
    //      BUSY
    stat=ReadCode();
    while(stat==(1<<7)) stat=ReadCode();
}


//    RESET
void WaitReset(void){
    unsigned char stat;
    stat=ReadCode();
    while(stat==(1<<4)) stat=ReadCode();
} 


//    ON/OFF
void WaitON(void){
    unsigned char stat;
    stat=ReadCode();
    while(stat==(1<<5)) stat=ReadCode();
}


/*     */
unsigned char ReadData( void ){
    unsigned char ret;
    //   
    WaitBusy();
    // 
    PORTE =0x00;
    DDRE=0x00; 
    //  
    (PORTA|=(1<<0     ));
    (PORTA|=(1<<1   )); 
    //                           
    delay_us(2);
    (PORTA|=(1<<2      )); 
    //                     
    delay_us(2);
    ret=PINE;         
    //  
    (PORTA&=~(1<<2      ));
    // 
    return ret;
 }


/*    
      */
void WriteData(unsigned char data){ 
    WaitBusy();   
    DDRE=0xFF;
    
    (PORTA|=(1<<0     ));
    (PORTA&=~(1<<1   ));
    
    delay_us(2);
    (PORTA|=(1<<2      ));
    PORTE =data;
                               
    delay_us(2);
    (PORTA&=~(1<<2      ));
}


/*    */
void WriteCode(unsigned char code){         
    WaitBusy();
    DDRE=0xFF;    
    
    (PORTA&=~(1<<0     ));
    (PORTA&=~(1<<1   ));
     
    delay_us(2);
    (PORTA|=(1<<2      ));
    PORTE =code;
    
    delay_us(2);
    (PORTA&=~(1<<2      ));
}


/*  */                              
void LCD_INIT( void ){ 
    //  Jtag
    MCUCSR = 0x80;
    MCUCSR = 0x80;
    // 
    DDRE=0xFF;           
    DDRA=0xFF;
    //     0.     RES
    PORTA=0x00;
    //    
    delay_ms(100); 
    //  .( RES )      
    (PORTA|=(1<<5    ));    
    // 1    
    (PORTA|=(1<<3     )); 
    //     
    WriteCode(0x3F);
    WriteCode(0xC0 | 0);

    (PORTA&=~(1<<3     ));
    //   2- 
    (PORTA|=(1<<4     ));
    WaitBusy();
    WriteCode(0x3F);
    WriteCode(0xC0 | 0);
}                                   

//  
void LCD_CLS(void){
    unsigned char i;
    unsigned char j;  

    (PORTA&=~(1<<4     )); 
    delay_us(2);
    (PORTA|=(1<<3     ));
    WriteCode(0x3E) ;
    WriteCode(0x40 | 0) ;
    for(i=0;i<8; i++){
        WriteCode(0xB8 | i);
        for(j=0; j<64; j++){
            WriteData(0x00);
        }
    }                  
    
    WriteCode(0x3F);
    (PORTA&=~(1<<3     ));
    delay_us(2);
    (PORTA|=(1<<4     ));
    WriteCode(0x3E) ;
    WriteCode(0x40 | 0) ;
    for(i=0;i<8; i++){
        WriteCode(0xB8 | i); 
        for(j=0; j<64; j++){
            WriteData(0x00);
        }
    } 
    WriteCode(0x3F);
}  
/*    */
void LCD_PUT_BYTE(unsigned char x, unsigned char y, unsigned char data){
void LCD_PUT_BYTE(unsigned char x, unsigned char y, unsigned char data){
    //  
    unsigned char page;
    unsigned char bite;
    //     
    if((x>127)|(y>63  )) return;
    //   63   
    if(x>=64){
        (PORTA&=~(1<<3     ));
        (PORTA|=(1<<4     ));
        x=x-64;
        }
        else{
        (PORTA&=~(1<<4     ));
        (PORTA|=(1<<3     ));
        }     
    //      
    page=y/8;
    bite=y%8;
    //   (     )
    //LCD_SET_PAGE(page);
    //LCD_SET_ADDRESS(x);
    // , 2 , ..     
    //tmp_data=ReadData(); 
    //tmp_data=ReadData();  
    //  
    WriteCode(0xB8 | page);
    WriteCode(0x40 | x) ;
    //                             
    switch(met){
    //    case MET_OR : {WriteData(tmp_data|(data<<bite)); break;}
    //    case MET_XOR : {WriteData(tmp_data^(data<<bite)); break;} 
    //    case MET_NOT_OR : {WriteData(tmp_data| ((data^0xFF)<<bite)); break;}
    //    case MET_NOT_XOR : {WriteData(tmp_data^((data^0xFF)<<bite)); break;}  
        case 0 : {WriteData(data<<bite); break;}
        case 1  : {WriteData(data<<bite); break;} 
        case 2 : {WriteData((data^0xFF)<<bite); break;}
        case 3 : {WriteData((data^0xFF)<<bite); break;}  
        }
    //          
    if(bite>0){ 
        WriteCode(0xB8 | page+1);
        WriteCode(0x40 | x) ;
       
    //    tmp_data=ReadData(); 
    //    tmp_data=ReadData();
        
    //    LCD_SET_PAGE(page+1);
    //    LCD_SET_ADDRESS(x);
    
        switch(met){
     //       case MET_OR : {WriteData(tmp_data|(data>>(8-bite))); break;}
     //       case MET_XOR : {WriteData(tmp_data^(data>>(8-bite))); break;} 
     //       case MET_NOT_OR : {WriteData(tmp_data|((data^0xFF)>>(8-bite))); break;}
     //       case MET_NOT_XOR : {WriteData(tmp_data^((data^0xFF)>>(8-bite))); break;} 
            case 0 : {WriteData(data>>(8-bite)); break;}
            case 1  : {WriteData(data>>(8-bite)); break;} 
            case 2 : {WriteData((data^0xFF)>>(8-bite)); break;}
            case 3 : {WriteData((data^0xFF)>>(8-bite)); break;} 
        }
    } 
}
/*  .     8*5 . */
void LCD_PUTC(unsigned char x, unsigned char y, unsigned char ch){
    unsigned char textL;
    unsigned char i;   
    //      ,   
    //   
    if(ch<0x90) textL=0x20;
    else textL=0x60;

    for(i=0; i<5; i++){
        LCD_PUT_BYTE(x+i, y, sym[ch-textL][i]);
        } 
    //  
    LCD_PUT_BYTE(x+i, y, 0x00);      
}   
/*     */            
void LCD_PUTSF(unsigned char x, unsigned char y, flash unsigned char str[]){
    unsigned char i=0;
    //     
    while(str[i]){
        LCD_PUTC(x+i*5+i, y, str[i]);
        i++; 
    }  
}
//========================================================================================================


int sec;


//_________________________________0__1__2__3__4__5__6__7__8__9__
flash unsigned char chislo[10] = {48,49,50,51,52,53,54,55,56,57};

flash unsigned char *month[12] = 
{       
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
"."
};                        

flash unsigned char *week[7] = 
{       
".",
".",
".",
".",
".",
".",
"."
};

char dat[10];
//dat[0] - ten hours
//dat[1] - one hours
//dat[2] - ten minutes
//dat[3] - one minutes
//dat[4] - week
//dat[5] - ten day
//dat[6] - one day
//dat[7] - month
//dat[8] - ten year
//dat[9] - one year




void set_month(unsigned char a, unsigned char b, char c, char d)
{

        if ((a == c) && (b == d))
        {
           dat[5] = 0;
           dat[6] = 1;        
           
           dat[7] = dat[7] + 1; // 
        }




}   


/*
==============================================================================================
	   Timer 0
==============================================================================================
*/   


interrupt [17] void timer0_ovf_isr (void)
{


        TCNT0=0x64;
        
        // 
        ((*(unsigned char *) 0x65)&=~(1<<0));
        delay_us(1);
        
        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Enter"); 
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Left "); 
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"0    "); 
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"7    "); 
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"4    "); 
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"1    "); 

        ((*(unsigned char *) 0x65)|=(1<<0));


        ((*(unsigned char *) 0x65)&=~(1<<2));
        delay_us(1);
        
        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Up   "); 
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Menu "); 
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"Down "); 
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"8    "); 
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"5    "); 
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"2    "); 

        ((*(unsigned char *) 0x65)|=(1<<2));

        (PORTC&=~(1<<0));
        delay_us(1);
        
        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Cancl"); 
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Right"); 
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"name "); 
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"9    "); 
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"6    "); 
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"3    "); 

        (PORTC|=(1<<0));




        

}




interrupt [15] void timer1_ovf_isr(void)
{           


        TCNT1H=0xE1;
        TCNT1L=0x7C;
        
        sec++;
        if (sec >= 60) 
        {
        sec = 0;

           dat[3] = dat[3]+1;
           if (dat[3] >= 10) 
           {
                dat[3] = 0; //  10  -> 0
                dat[2] = dat[2] + 1;

                if (dat[2] >= 6) 
                {
                   dat[2] = 0;
                   dat[1] = dat[1] + 1;                            
                   
                   if (dat[1] >= 10) 
                   {
                     dat[1] = 0;
                     dat[0] = dat[0] + 1;
                   }

                   if (dat[0] >= 2) 
                   {

                     if (dat[1] >= 4) 
                     //    (24 )
                     {
                         dat[1] = 0;
                         dat[0] = 0;
                         dat[4] = dat[4] + 1;
                         
                         if (dat[4] >= 7)  // 
                         {
                            dat[4] = 0;
                         }
                        
                         dat[6] = dat[6] + 1;
                         if (dat[6] >= 10)
                         //  10 
                         {
                            dat[6] = 0;           //  
                            dat[5] = dat[5] + 1;  //  
                         }

                         //   
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(2,8,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  

                         
                         if (dat[7] >= 12)  // 12 
                         {
                             dat[7] = 0;
                             
                             dat[9] = dat[9] + 1;
                             if (dat[9] >= 10)
                             {
                                dat[9] = 0;
                                dat[8] = dat[8] + 1;
                                
                                if (dat[8] == 10) dat[8] = 0;
                             
                             }
                         }
                     }
                   }
                }
           }


        met=1 ;
        LCD_PUTC(0,0,chislo[dat[0]]); 

        met=1 ;
        LCD_PUTC(6,0,chislo[dat[1]]); 

        met=1 ;
        LCD_PUTSF(12,0,":"); 

        met=1 ;
        LCD_PUTC(18,0,chislo[dat[2]]); 

        met=1 ;
        LCD_PUTC(24,0,chislo[dat[3]]); 

        met=1 ;
        LCD_PUTSF(36,0,week[dat[4]]); 

        met=1 ;
        LCD_PUTC(65,0,chislo[dat[5]]); 

        met=1 ;
        LCD_PUTC(71,0,chislo[dat[6]]); 

        met=1 ;
        LCD_PUTSF(80,0,month[dat[7]]); 


        met=1 ;
        LCD_PUTSF(104,0,"20"); 

          
        met=1 ;
        LCD_PUTC(116,0,chislo[dat[8]]); 

        met=1 ;
        LCD_PUTC(122,0,chislo[dat[9]]); 

        }
}



void main(void)
{

	//  
	// Port D
	PORTD = 0xFF;
	DDRD = 0xFF;

	// Port B
	PORTB=0xFF;
	DDRB = 0xFF;

	// Port A
        PORTA = 0xFF;
	DDRA = 0xFF;
	
	// Port C
        PORTC = 0b11111110;
	DDRC = 0b00000001;
	
	// Port E
        PORTE = 0xFF;
	DDRE = 0xFF;
	
	// Port F
        (*(unsigned char *) 0x62) = 0xFF;
	(*(unsigned char *) 0x61) = 0xFF;
	
	
	// Port G
        (*(unsigned char *) 0x65) = 0b1111;
	(*(unsigned char *) 0x64) = 0x1111;
	

	//  Timer 0
	TCCR0=0x05;
	TCNT0=0x64;         

	//  Timer 1
        TCCR1B=0x05;
        TCCR1A=0x00;
        TCNT1H=0xE1;
        TCNT1L=0x7C;
        OCR1BL=0x00;
        OCR1BH=0x00;
        OCR1AL=0x00;
        OCR1AH=0x00;




        // Timer(s)/Counter(s) Interrupt(s) initialization
	TIMSK=0b101;


        


        LCD_INIT();  
        
        met=0;
        LCD_CLS(); 

        sec = 0;
        
        //dat[0] - ten hours
        //dat[1] - one hours
        //dat[2] - ten minutes
        //dat[3] - one minutes
        //dat[4] - week
        //dat[5] - ten day
        //dat[6] - one day
        //dat[7] - month
        //dat[8] - ten year
        //dat[9] - one year
          dat[0] = 0;
          dat[1] = 0;
          dat[2] = 0;
          dat[3] = 0;
          dat[4] = 4;
          dat[5] = 1;
          dat[6] = 9;
          dat[7] = 1;
          dat[8] = 1;
          dat[9] = 0;


        met=1 ;
        LCD_PUTC(0,0,chislo[dat[0]]); 

        met=1 ;
        LCD_PUTC(6,0,chislo[dat[1]]); 

        met=1 ;
        LCD_PUTSF(12,0,":"); 

        met=1 ;
        LCD_PUTC(18,0,chislo[dat[2]]); 

        met=1 ;
        LCD_PUTC(24,0,chislo[dat[3]]); 

        met=1 ;
        LCD_PUTSF(36,0,week[dat[4]]); 

        met=1 ;
        LCD_PUTC(65,0,chislo[dat[5]]); 

        met=1 ;
        LCD_PUTC(71,0,chislo[dat[6]]); 

        met=1 ;
        LCD_PUTSF(80,0,month[dat[7]]); 


        met=1 ;
        LCD_PUTSF(104,0,"20"); 

          
        met=1 ;
        LCD_PUTC(116,0,chislo[dat[8]]); 

        met=1 ;
        LCD_PUTC(122,0,chislo[dat[9]]); 


//        met=MET_XOR;
//        LCD_PUTSF(0,0,"Display ON ..."); 

//        met=MET_NOT_XOR;
//        LCD_PUTSF(56,10,"radiokot");  



#asm
        sei
#endasm


while (1){ 


        };          
}
