/***********************************************************************

  LCD  ATmega32    : 

http://www.radiokot.ru/forum/viewtopic.php?t=5199&postdays=0&postorder=asc&start=20

:  lexmulya  ( 17, 2007 10:11 am)     . 
               
   (     ). 
  ,      . 
          
         , 
   ,    70 .

*************************************************************************
                      

AVR123.NM.RU -     CVAVR    PROTEUS  
     

LCD           ATmega32     12 

DI    PA0 
RW    PA1
E     PA2
CS1   PA3 
CS2   PA4
RST   PA5

 PCx      DBx  LCD

   CVAVR 1.25.8 pro,    , 

    PROTEUS 7.2
                                                            
*******************************  2008-05-16  ******************************

  :

http://www.roboforum.ru/viewtopic.php?f=2&t=1070

     AVR  -  www.AVR123.NM.RU

   PROTEUS  -  oProteus.narod.ru  -    !

    AVR  -  www.AVR123.NM.RU/06.htm

*************************************************************************/


#include <mega64.h>

#include <stdio.h>
#include <delay.h>  


//========================================================================================================
#include <macros.h>
#include <sym.h>
#include <config.h> 
#include <driver.h>
#include <driver.c>  
#include <text.c>
//========================================================================================================


int sec;


//_________________________________0__1__2__3__4__5__6__7__8__9__
flash unsigned char chislo[10] = {48,49,50,51,52,53,54,55,56,57};

flash unsigned char *month[12] = 
{       
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
"."
};                        

flash unsigned char *week[7] = 
{       
".",
".",
".",
".",
".",
".",
"."
};

char dat[10];
//dat[0] - ten hours
//dat[1] - one hours
//dat[2] - ten minutes
//dat[3] - one minutes
//dat[4] - week
//dat[5] - ten day
//dat[6] - one day
//dat[7] - month
//dat[8] - ten year
//dat[9] - one year




void set_month(byte a, byte b, char c, char d)
{

        if ((a == c) && (b == d))
        {
           dat[5] = 0;
           dat[6] = 1;        
           
           dat[7] = dat[7] + 1; // 
        }




}   


/*
==============================================================================================
	   Timer 0
==============================================================================================
*/   


interrupt [TIM0_OVF] void timer0_ovf_isr (void)
{


        TCNT0=0x64;
        
        // 
        ClrBit(PORTG,0);
        delay_us(1);
        
        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Enter"); 
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Left "); 
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"0    "); 
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"7    "); 
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"4    "); 
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"1    "); 

        SetBit(PORTG,0);


        ClrBit(PORTG,1);
        delay_us(1);
        
        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Up   "); 
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Menu "); 
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"Down "); 
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"8    "); 
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"5    "); 
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"2    "); 

        SetBit(PORTG,1);

        ClrBit(PORTC,0);
        delay_us(1);
        
        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Cancl"); 
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Right"); 
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"name "); 
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"9    "); 
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"6    "); 
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"3    "); 

        SetBit(PORTC,0);




        

}




interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{           


        TCNT1H=0xE1;
        TCNT1L=0x7C;
        
        sec++;
        if (sec >= 60) 
        {
        sec = 0;

           dat[3] = dat[3]+1;
           if (dat[3] >= 10) 
           {
                dat[3] = 0; //  10  -> 0
                dat[2] = dat[2] + 1;

                if (dat[2] >= 6) 
                {
                   dat[2] = 0;
                   dat[1] = dat[1] + 1;                            
                   
                   if (dat[1] >= 10) 
                   {
                     dat[1] = 0;
                     dat[0] = dat[0] + 1;
                   }

                   if (dat[0] >= 2) 
                   {

                     if (dat[1] >= 4) 
                     //    (24 )
                     {
                         dat[1] = 0;
                         dat[0] = 0;
                         dat[4] = dat[4] + 1;
                         
                         if (dat[4] >= 7)  // 
                         {
                            dat[4] = 0;
                         }
                        
                         dat[6] = dat[6] + 1;
                         if (dat[6] >= 10)
                         //  10 
                         {
                            dat[6] = 0;           //  
                            dat[5] = dat[5] + 1;  //  
                         }

                         //   
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(2,8,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  

                         
                         if (dat[7] >= 12)  // 12 
                         {
                             dat[7] = 0;
                             
                             dat[9] = dat[9] + 1;
                             if (dat[9] >= 10)
                             {
                                dat[9] = 0;
                                dat[8] = dat[8] + 1;
                                
                                if (dat[8] == 10) dat[8] = 0;
                             
                             }
                         }
                     }
                   }
                }
           }


        met=MET_XOR;
        LCD_PUTC(0,0,chislo[dat[0]]); 

        met=MET_XOR;
        LCD_PUTC(6,0,chislo[dat[1]]); 

        met=MET_XOR;
        LCD_PUTSF(12,0,":"); 

        met=MET_XOR;
        LCD_PUTC(18,0,chislo[dat[2]]); 

        met=MET_XOR;
        LCD_PUTC(24,0,chislo[dat[3]]); 

        met=MET_XOR;
        LCD_PUTSF(36,0,week[dat[4]]); 

        met=MET_XOR;
        LCD_PUTC(65,0,chislo[dat[5]]); 

        met=MET_XOR;
        LCD_PUTC(71,0,chislo[dat[6]]); 

        met=MET_XOR;
        LCD_PUTSF(80,0,month[dat[7]]); 


        met=MET_XOR;
        LCD_PUTSF(104,0,"20"); 

          
        met=MET_XOR;
        LCD_PUTC(116,0,chislo[dat[8]]); 

        met=MET_XOR;
        LCD_PUTC(122,0,chislo[dat[9]]); 

        }
}



void main(void)
{

	//  
	// Port D
	PORTD = 0xFF;
	DDRD = 0xFF;

	// Port B
	PORTB=0xFF;
	DDRB = 0xFF;

	// Port A
        PORTA = 0xFF;
	DDRA = 0xFF;
	
	// Port C
        PORTC = 0b11111110;
	DDRC = 0b00000001;
	
	// Port E
        PORTE = 0xFF;
	DDRE = 0xFF;
	
	// Port F
        PORTF = 0xFF;
	DDRF = 0xFF;
	
	
	// Port G
        PORTG = 0b1111;
	DDRG = 0x1111;
	

	//  Timer 0
	TCCR0=0x05;
	TCNT0=0x64;         

	//  Timer 1
        TCCR1B=0x05;
        TCCR1A=0x00;
        TCNT1H=0xE1;
        TCNT1L=0x7C;
        OCR1BL=0x00;
        OCR1BH=0x00;
        OCR1AL=0x00;
        OCR1AH=0x00;




        // Timer(s)/Counter(s) Interrupt(s) initialization
	TIMSK=0b101;


        


        LCD_INIT();  
        
        met=MET_OR;
        LCD_CLS(); 

        sec = 0;
        
        //dat[0] - ten hours
        //dat[1] - one hours
        //dat[2] - ten minutes
        //dat[3] - one minutes
        //dat[4] - week
        //dat[5] - ten day
        //dat[6] - one day
        //dat[7] - month
        //dat[8] - ten year
        //dat[9] - one year
          dat[0] = 0;
          dat[1] = 0;
          dat[2] = 0;
          dat[3] = 0;
          dat[4] = 4;
          dat[5] = 1;
          dat[6] = 9;
          dat[7] = 1;
          dat[8] = 1;
          dat[9] = 0;


        met=MET_XOR;
        LCD_PUTC(0,0,chislo[dat[0]]); 

        met=MET_XOR;
        LCD_PUTC(6,0,chislo[dat[1]]); 

        met=MET_XOR;
        LCD_PUTSF(12,0,":"); 

        met=MET_XOR;
        LCD_PUTC(18,0,chislo[dat[2]]); 

        met=MET_XOR;
        LCD_PUTC(24,0,chislo[dat[3]]); 

        met=MET_XOR;
        LCD_PUTSF(36,0,week[dat[4]]); 

        met=MET_XOR;
        LCD_PUTC(65,0,chislo[dat[5]]); 

        met=MET_XOR;
        LCD_PUTC(71,0,chislo[dat[6]]); 

        met=MET_XOR;
        LCD_PUTSF(80,0,month[dat[7]]); 


        met=MET_XOR;
        LCD_PUTSF(104,0,"20"); 

          
        met=MET_XOR;
        LCD_PUTC(116,0,chislo[dat[8]]); 

        met=MET_XOR;
        LCD_PUTC(122,0,chislo[dat[9]]); 


//        met=MET_XOR;
//        LCD_PUTSF(0,0,"Display ON ..."); 

//        met=MET_NOT_XOR;
//        LCD_PUTSF(56,10,"radiokot");  



#asm
        sei
#endasm


while (1){ 


        };          
}
